GNU bug report logs - #47832
28.0.50; define-fringe-bitmap and emacs --daemon

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Gregory Heytings <gregory@HIDDEN>; Keywords: patch; dated Fri, 16 Apr 2021 22:23:01 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.
Added tag(s) patch. Request was from Stefan Kangas <stefan@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 47832 <at> debbugs.gnu.org:


Received: (at 47832) by debbugs.gnu.org; 17 Apr 2021 12:52:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Apr 17 08:52:11 2021
Received: from localhost ([127.0.0.1]:42455 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lXkQl-0007Ls-Es
	for submit <at> debbugs.gnu.org; Sat, 17 Apr 2021 08:52:11 -0400
Received: from heytings.org ([95.142.160.155]:41654)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <gregory@HIDDEN>) id 1lXkQj-0007Lj-Hn
 for 47832 <at> debbugs.gnu.org; Sat, 17 Apr 2021 08:52:10 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=heytings.org;
 s=20210101; t=1618663928;
 bh=Cv6ba5yg6wMkxb+0Hg5CackgerrB0bWnuCUh1RxUSt0=;
 h=Date:From:To:cc:Subject:In-Reply-To:Message-ID:References:From;
 b=QLNxVkAMg02RKSm1euXjCkuf44R0rT1+BPWq0XNHHa2yNHtB4FmoXT93HYEMGvA7K
 1NYK7XSCU20TfFNVHRiYFxVv0iClM2H8eq9AHJP4ul5rdEVI3RLNvQUBX3EVSTPaS9
 LFLaboGci1L4qRO7PCTGwMfP/Af4MgaLiKNe4NqZNCRFfJk1TKl0zdA43arO9tUsAw
 U3Oho5UI2A0s4X2mQzDzBdsN6bHZjc5K1Ef/ksPeaikBb7xYkRMHH3zNF9v7I7Ql4T
 uUpfm6cJ9SWpYPppxJtz1oXV/dzMgzJBl+AHG1IGmcjSLgKvE7Yz+acRgGE2qpoC5q
 2q9pQAnFv97sw==
Date: Sat, 17 Apr 2021 12:52:08 +0000
From: Gregory Heytings <gregory@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#47832: 28.0.50; define-fringe-bitmap and emacs --daemon
In-Reply-To: <83eef9w0xd.fsf@HIDDEN>
Message-ID: <1869622e16270efbc7e8@HIDDEN>
References: <7dee3f4235cf450a3254@HIDDEN> <83mttxwgm8.fsf@HIDDEN>
 <1869622e16688e6aedec@HIDDEN> <83h7k5w54l.fsf@HIDDEN>
 <83fszpw40t.fsf@HIDDEN> <1869622e16c60dc2ce0d@HIDDEN>
 <83eef9w0xd.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="B7fHCgR0Yd"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 47832
Cc: 47832 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


--B7fHCgR0Yd
Content-Type: text/plain; format=flowed; charset=us-ascii


>>> And in any case, the patch for gui_init_fringe is sub-optimal: it 
>>> unnecessarily loops over the standard bitmaps that were superseded. It 
>>> is better to leave the first loop go over the standard bitmaps, 
>>> whether superseded or not, and the second loop go over non-standard 
>>> bitmaps only.
>>
>> It is not sub-optimal, rif->define_fringe_bitmap will only be called 
>> for those standard bitmaps that were superseded.  For the 
>> non-superseded ones, fringe_bitmaps[bt] is NULL.
>
> I meant the first loop, not the second one.
>

Okay, the patch was meant only to fix the bug, but indeed the small 
optimization you mention makes sense.  Updated patch attached.
--B7fHCgR0Yd
Content-Type: text/x-diff; name=Consider-all-user-defined-bitmaps-in-gui_init_fringe.patch
Content-Transfer-Encoding: base64
Content-ID: <1869622e163a73965b25@HIDDEN>
Content-Description: 
Content-Disposition: attachment; filename=Consider-all-user-defined-bitmaps-in-gui_init_fringe.patch

RnJvbSBkMDJhZjJjNzAwN2IyYmEyZmZhNmMwZmI0N2UzM2U2NTExNjgwOGM0
IE1vbiBTZXAgMTcgMDA6MDA6MDAgMjAwMQ0KRnJvbTogR3JlZ29yeSBIZXl0
aW5ncyA8Z3JlZ29yeUBoZXl0aW5ncy5vcmc+DQpEYXRlOiBTYXQsIDE3IEFw
ciAyMDIxIDEyOjQ4OjQ4ICswMDAwDQpTdWJqZWN0OiBbUEFUQ0hdIENvbnNp
ZGVyIGFsbCB1c2VyLWRlZmluZWQgYml0bWFwcyBpbiBndWlfaW5pdF9mcmlu
Z2UoKQ0KDQoqIHNyYy9mcmluZ2UuYyAoZ3VpX2luaXRfZnJpbmdlKTogQ29u
c2lkZXIgdXNlci1kZWZpbmVkIGJpdG1hcHMgdGhhdA0Kb3ZlcnJpZGUgZGVm
YXVsdCBvbmVzIChCdWcjNDc4MzIpLg0KLS0tDQogc3JjL2ZyaW5nZS5jIHwg
NSArKystLQ0KIDEgZmlsZSBjaGFuZ2VkLCAzIGluc2VydGlvbnMoKyksIDIg
ZGVsZXRpb25zKC0pDQoNCmRpZmYgLS1naXQgYS9zcmMvZnJpbmdlLmMgYi9z
cmMvZnJpbmdlLmMNCmluZGV4IDY1YzlhODRhYzkuLjQ3NjE1ZjUxZjkgMTAw
NjQ0DQotLS0gYS9zcmMvZnJpbmdlLmMNCisrKyBiL3NyYy9mcmluZ2UuYw0K
QEAgLTE3NzYsMTQgKzE3NzYsMTUgQEAgZ3VpX2luaXRfZnJpbmdlIChzdHJ1
Y3QgcmVkaXNwbGF5X2ludGVyZmFjZSAqcmlmKQ0KICAgZm9yIChidCA9IE5P
X0ZSSU5HRV9CSVRNQVAgKyAxOyBidCA8IE1BWF9TVEFOREFSRF9GUklOR0Vf
QklUTUFQUzsgYnQrKykNCiAgICAgew0KICAgICAgIHN0cnVjdCBmcmluZ2Vf
Yml0bWFwICpmYiA9ICZzdGFuZGFyZF9iaXRtYXBzW2J0XTsNCi0gICAgICBy
aWYtPmRlZmluZV9mcmluZ2VfYml0bWFwIChidCwgZmItPmJpdHMsIGZiLT5o
ZWlnaHQsIGZiLT53aWR0aCk7DQorICAgICAgaWYgKCFmcmluZ2VfYml0bWFw
c1tidF0pDQorICAgICAgICByaWYtPmRlZmluZV9mcmluZ2VfYml0bWFwIChi
dCwgZmItPmJpdHMsIGZiLT5oZWlnaHQsIGZiLT53aWR0aCk7DQogICAgIH0N
CiANCiAgIC8qIFNldCB1cCB1c2VyLWRlZmluZWQgZnJpbmdlIGJpdG1hcHMg
dGhhdCBtaWdodCBoYXZlIGJlZW4gZGVmaW5lZA0KICAgICAgYmVmb3JlIHRo
ZSBmcmFtZSBvZiB0aGlzIGtpbmQgd2FzIGluaXRpYWxpemVkLiAgVGhpcyBj
YW4gaGFwcGVuDQogICAgICBpZiBFbWFjcyBpcyBzdGFydGVkIGFzIGEgZGFl
bW9uIGFuZCB0aGUgaW5pdCBmaWxlcyBkZWZpbmUgZnJpbmdlDQogICAgICBi
aXRtYXBzLiAgKi8NCi0gIGZvciAoIDsgYnQgPCBtYXhfdXNlZF9mcmluZ2Vf
Yml0bWFwOyBidCsrKQ0KKyAgZm9yIChidCA9IE5PX0ZSSU5HRV9CSVRNQVAg
KyAxOyBidCA8IG1heF91c2VkX2ZyaW5nZV9iaXRtYXA7IGJ0KyspDQogICAg
IHsNCiAgICAgICBzdHJ1Y3QgZnJpbmdlX2JpdG1hcCAqZmIgPSBmcmluZ2Vf
Yml0bWFwc1tidF07DQogICAgICAgaWYgKGZiKQ0KLS0gDQoyLjMwLjINCg0K

--B7fHCgR0Yd--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47832; Package emacs. Full text available.

Message received at 47832 <at> debbugs.gnu.org:


Received: (at 47832) by debbugs.gnu.org; 17 Apr 2021 12:28:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Apr 17 08:28:57 2021
Received: from localhost ([127.0.0.1]:42438 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lXk4H-0006h0-2R
	for submit <at> debbugs.gnu.org; Sat, 17 Apr 2021 08:28:57 -0400
Received: from eggs.gnu.org ([209.51.188.92]:35526)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lXk4E-0006gj-Ra
 for 47832 <at> debbugs.gnu.org; Sat, 17 Apr 2021 08:28:55 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:60945)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lXk49-0006ef-Lr; Sat, 17 Apr 2021 08:28:49 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4849
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lXk48-0006Zs-CZ; Sat, 17 Apr 2021 08:28:49 -0400
Date: Sat, 17 Apr 2021 15:28:44 +0300
Message-Id: <83czutw0w3.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Gregory Heytings <gregory@HIDDEN>
In-Reply-To: <1869622e16ba14990471@HIDDEN> (message from Gregory
 Heytings on Sat, 17 Apr 2021 11:34:06 +0000)
Subject: Re: bug#47832: 28.0.50; define-fringe-bitmap and emacs --daemon
References: <7dee3f4235cf450a3254@HIDDEN> <83mttxwgm8.fsf@HIDDEN>
 <1869622e16688e6aedec@HIDDEN> <83h7k5w54l.fsf@HIDDEN>
 <83fszpw40t.fsf@HIDDEN> <1869622e16ba14990471@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47832
Cc: 47832 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> Date: Sat, 17 Apr 2021 11:34:06 +0000
> From: Gregory Heytings <gregory@HIDDEN>
> cc: 47832 <at> debbugs.gnu.org
> 
> > Since gui_init_fringe returns immediately if the frame interface doesn't 
> > provide a method for fringe initialization, I think we should call 
> > gui_init_fringe unconditionally on X.
> >
> 
> Wouldn't that leave the bug unfixed on Windows?

No, because Windows calls it in another place.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47832; Package emacs. Full text available.

Message received at 47832 <at> debbugs.gnu.org:


Received: (at 47832) by debbugs.gnu.org; 17 Apr 2021 12:28:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Apr 17 08:28:21 2021
Received: from localhost ([127.0.0.1]:42433 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lXk3g-0006fs-Py
	for submit <at> debbugs.gnu.org; Sat, 17 Apr 2021 08:28:21 -0400
Received: from eggs.gnu.org ([209.51.188.92]:35476)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lXk3e-0006fd-Qg
 for 47832 <at> debbugs.gnu.org; Sat, 17 Apr 2021 08:28:19 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:60943)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lXk3Y-0006Gf-4W; Sat, 17 Apr 2021 08:28:12 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4802
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lXk3N-0005Oy-TH; Sat, 17 Apr 2021 08:28:06 -0400
Date: Sat, 17 Apr 2021 15:27:58 +0300
Message-Id: <83eef9w0xd.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Gregory Heytings <gregory@HIDDEN>
In-Reply-To: <1869622e16c60dc2ce0d@HIDDEN> (message from Gregory
 Heytings on Sat, 17 Apr 2021 11:32:25 +0000)
Subject: Re: bug#47832: 28.0.50; define-fringe-bitmap and emacs --daemon
References: <7dee3f4235cf450a3254@HIDDEN> <83mttxwgm8.fsf@HIDDEN>
 <1869622e16688e6aedec@HIDDEN> <83h7k5w54l.fsf@HIDDEN>
 <83fszpw40t.fsf@HIDDEN> <1869622e16c60dc2ce0d@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47832
Cc: 47832 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> Date: Sat, 17 Apr 2021 11:32:25 +0000
> From: Gregory Heytings <gregory@HIDDEN>
> cc: 47832 <at> debbugs.gnu.org
> 
> > Since gui_init_fringe returns immediately if the frame interface doesn't 
> > provide a method for fringe initialization, I think we should call 
> > gui_init_fringe unconditionally on X.

Here I meant to call gui_init_fringe unconditionally.  It will make
the code less confusing.

> > And in any case, the patch for gui_init_fringe is sub-optimal: it 
> > unnecessarily loops over the standard bitmaps that were superseded. It 
> > is better to leave the first loop go over the standard bitmaps, whether 
> > superseded or not, and the second loop go over non-standard bitmaps 
> > only.
> 
> It is not sub-optimal, rif->define_fringe_bitmap will only be called for 
> those standard bitmaps that were superseded.  For the non-superseded ones, 
> fringe_bitmaps[bt] is NULL.

I meant the first loop, not the second one.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47832; Package emacs. Full text available.

Message received at 47832 <at> debbugs.gnu.org:


Received: (at 47832) by debbugs.gnu.org; 17 Apr 2021 11:34:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Apr 17 07:34:09 2021
Received: from localhost ([127.0.0.1]:42388 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lXjDF-0005HS-BW
	for submit <at> debbugs.gnu.org; Sat, 17 Apr 2021 07:34:09 -0400
Received: from heytings.org ([95.142.160.155]:41568)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <gregory@HIDDEN>) id 1lXjDD-0005HK-QL
 for 47832 <at> debbugs.gnu.org; Sat, 17 Apr 2021 07:34:08 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=heytings.org;
 s=20210101; t=1618659247;
 bh=R3MSUfHp37ImealxWwEdJ5l7JKsF11X9GaV+cfhL+9I=;
 h=Date:From:To:cc:Subject:In-Reply-To:Message-ID:References:From;
 b=ufw/YrmvyQpIZnt0w0eXezHXjEIl/PE8o8qsAPesUlblwh9H/Iun9epZYggz9lsbK
 dZmLkalEFHkiVGeBMxXEsbRwFWxkxVpUwO5h9maIFVS2Mbp/NQWhdUC4W9XPM0y00l
 tpb+YDgqCUer4lKkE8IC7V0ldD2gjFRFR3rmhTRNcx5PMOSFpcKPJZB01pY3XPd5DP
 AndoqF25crOITXQTUG3fwPEMrDtGc9DEJENu9m+oBw+/Jv8PJ2SxDPrhk72RSM21LP
 VIQhjs33AnDX4oN03kRpCDbB4Y6TJVhBUf6ZM1Vc7v8blTBJcmEqj9lM5vtb1Mx/tW
 eYZDS2S5LkoHQ==
Date: Sat, 17 Apr 2021 11:34:06 +0000
From: Gregory Heytings <gregory@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#47832: 28.0.50; define-fringe-bitmap and emacs --daemon
In-Reply-To: <83fszpw40t.fsf@HIDDEN>
Message-ID: <1869622e16ba14990471@HIDDEN>
References: <7dee3f4235cf450a3254@HIDDEN> <83mttxwgm8.fsf@HIDDEN>
 <1869622e16688e6aedec@HIDDEN> <83h7k5w54l.fsf@HIDDEN>
 <83fszpw40t.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii; format=flowed
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 47832
Cc: 47832 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


>
> Since gui_init_fringe returns immediately if the frame interface doesn't 
> provide a method for fringe initialization, I think we should call 
> gui_init_fringe unconditionally on X.
>

Wouldn't that leave the bug unfixed on Windows?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47832; Package emacs. Full text available.

Message received at 47832 <at> debbugs.gnu.org:


Received: (at 47832) by debbugs.gnu.org; 17 Apr 2021 11:32:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Apr 17 07:32:28 2021
Received: from localhost ([127.0.0.1]:42383 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lXjBc-0005Eb-04
	for submit <at> debbugs.gnu.org; Sat, 17 Apr 2021 07:32:28 -0400
Received: from heytings.org ([95.142.160.155]:41558)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <gregory@HIDDEN>) id 1lXjBa-0005EQ-CQ
 for 47832 <at> debbugs.gnu.org; Sat, 17 Apr 2021 07:32:26 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=heytings.org;
 s=20210101; t=1618659145;
 bh=n2/AMfGoOxFSZ0cV5INz0T3ywyFMBCgHBUaRhLuJFdM=;
 h=Date:From:To:cc:Subject:In-Reply-To:Message-ID:References:From;
 b=Fb06fU/lWCsGfiyc3uMY7nwIVw8ctF6ZLeoM2wVLTJ6/vit73rz+KVM13S1gXxMX4
 VQGgf5CWfhIq4eIPfdimGEPzso0c+KEDIxz7ITnWv3/XQ2QpzaeyhJ4Zyx4LJzvjvB
 WTYImPsLp5EUSIUoG1WCr2z41BtVSt9cLKVhbQrKxOGRvQcFIqvexfCZ71s2X3HmYm
 1UiT1Y5jhOLdWCeONMjROVeOJC4eVDdc8tMXVE2itPi+6EIptbb72OPhuNuNmY3wLC
 w3wg7FvCWIox/wXMbSUMP414DAFXYlx3PKGZo0pdACDFzy1KwRH67Q+OXf8lFQ57dn
 RWqazSLIwJ+gA==
Date: Sat, 17 Apr 2021 11:32:25 +0000
From: Gregory Heytings <gregory@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#47832: 28.0.50; define-fringe-bitmap and emacs --daemon
In-Reply-To: <83fszpw40t.fsf@HIDDEN>
Message-ID: <1869622e16c60dc2ce0d@HIDDEN>
References: <7dee3f4235cf450a3254@HIDDEN> <83mttxwgm8.fsf@HIDDEN>
 <1869622e16688e6aedec@HIDDEN> <83h7k5w54l.fsf@HIDDEN>
 <83fszpw40t.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii; format=flowed
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 47832
Cc: 47832 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


>>> Got it! :-)  The commit I identified is indeed the culprit.  With 
>>> USE_CAIRO, gui_init_fringe() is called in x_initialize(); without 
>>> USE_CAIRO it isn't.  And gui_init_fringe() had a bug, which should now 
>>> be fixed on Windows, too.  Patch attached.
>>
>> Thanks, but is this really all that needs to be done?  How will 
>> gui_init_fringe be called in the non-Cairo builds?  And what about NS?
>
> Answering myself: they don't need to call gui_init_fringe.
>

Indeed.

>
> Since gui_init_fringe returns immediately if the frame interface doesn't 
> provide a method for fringe initialization, I think we should call 
> gui_init_fringe unconditionally on X.
>
> And in any case, the patch for gui_init_fringe is sub-optimal: it 
> unnecessarily loops over the standard bitmaps that were superseded. It 
> is better to leave the first loop go over the standard bitmaps, whether 
> superseded or not, and the second loop go over non-standard bitmaps 
> only.
>

It is not sub-optimal, rif->define_fringe_bitmap will only be called for 
those standard bitmaps that were superseded.  For the non-superseded ones, 
fringe_bitmaps[bt] is NULL.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47832; Package emacs. Full text available.

Message received at 47832 <at> debbugs.gnu.org:


Received: (at 47832) by debbugs.gnu.org; 17 Apr 2021 11:28:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Apr 17 07:28:03 2021
Received: from localhost ([127.0.0.1]:42369 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lXj7L-0002zR-K9
	for submit <at> debbugs.gnu.org; Sat, 17 Apr 2021 07:28:03 -0400
Received: from heytings.org ([95.142.160.155]:41546)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <gregory@HIDDEN>) id 1lXj7G-0002yz-5W
 for 47832 <at> debbugs.gnu.org; Sat, 17 Apr 2021 07:28:02 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=heytings.org;
 s=20210101; t=1618658877;
 bh=nWdITWnehK34JeZs65RYBHoAOxozsmihJkhAlKUZhjo=;
 h=Date:From:To:cc:Subject:In-Reply-To:Message-ID:References:From;
 b=o6mzFY5duBQ1N6IaOTMFF3dufFpgOi2Fmhp/rzukkRYdETK9dXvLIGkbmcR6B/Ms2
 enmrdrmzsfoy8vmtwzzNqvKhNYzkwjZBdSkOTkBWwBqhdqTtKwLCSdezGxU7X6I7Tz
 L8iV+X6jwi0jsRkFbuF/RraQs6gdkMqK/GrS7lxSqP4/AGX4Ur/L8eKAtvzQG2JsEC
 JpO1DirG4ftLImuYToUmevWBw6IOQ0AUmkUaHe4fZTXDT8ydfYiEBIW0iXwBA7atQI
 H5aAPoyeYHAxI0VFSNOpKZ+dAlXq3BmYXWl7s7Egjz/kbV9jRusUQLADoUBLCbv1cp
 C9DA+U8MZyM0A==
Date: Sat, 17 Apr 2021 11:27:56 +0000
From: Gregory Heytings <gregory@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#47832: 28.0.50; define-fringe-bitmap and emacs --daemon
In-Reply-To: <83h7k5w54l.fsf@HIDDEN>
Message-ID: <1869622e16c4eb74d974@HIDDEN>
References: <7dee3f4235cf450a3254@HIDDEN> <83mttxwgm8.fsf@HIDDEN>
 <1869622e16688e6aedec@HIDDEN> <83h7k5w54l.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed; charset=us-ascii
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 47832
Cc: 47832 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


>> This used to work indeed; it worked on GNU/Linux with default 
>> (non-Cairo) builds for Emacs 24 to 27.
>
> And with Emacs 28 it doesn't work in non-Cairo builds?
>

Yes, with Emacs 28 it works with non-Cairo builds.

>> Got it! :-)  The commit I identified is indeed the culprit.  With 
>> USE_CAIRO, gui_init_fringe() is called in x_initialize(); without 
>> USE_CAIRO it isn't.  And gui_init_fringe() had a bug, which should now 
>> be fixed on Windows, too.  Patch attached.
>
> Thanks, but is this really all that needs to be done?  How will 
> gui_init_fringe be called in the non-Cairo builds?  And what about NS?
>

On non-Cairo builds gui_init_finge is not called, the only call to 
gui_init_fringe in xterm.c is inside an #if USE_CAIRO.  And on NS 
gui_init_fringe isn't called either.  I just checked, NS builds are not 
affected by this bug.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47832; Package emacs. Full text available.

Message received at 47832 <at> debbugs.gnu.org:


Received: (at 47832) by debbugs.gnu.org; 17 Apr 2021 11:21:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Apr 17 07:21:23 2021
Received: from localhost ([127.0.0.1]:42364 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lXj0s-0002q4-Sl
	for submit <at> debbugs.gnu.org; Sat, 17 Apr 2021 07:21:23 -0400
Received: from eggs.gnu.org ([209.51.188.92]:54036)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lXj0r-0002pr-Cp
 for 47832 <at> debbugs.gnu.org; Sat, 17 Apr 2021 07:21:21 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:60238)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lXj0k-0006dy-Jm; Sat, 17 Apr 2021 07:21:15 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4704
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lXj0j-00086o-B8; Sat, 17 Apr 2021 07:21:14 -0400
Date: Sat, 17 Apr 2021 14:21:06 +0300
Message-Id: <83fszpw40t.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: gregory@HIDDEN
In-Reply-To: <83h7k5w54l.fsf@HIDDEN> (message from Eli Zaretskii on Sat, 17
 Apr 2021 13:57:14 +0300)
Subject: Re: bug#47832: 28.0.50; define-fringe-bitmap and emacs --daemon
References: <7dee3f4235cf450a3254@HIDDEN> <83mttxwgm8.fsf@HIDDEN>
 <1869622e16688e6aedec@HIDDEN> <83h7k5w54l.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47832
Cc: 47832 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> Date: Sat, 17 Apr 2021 13:57:14 +0300
> From: Eli Zaretskii <eliz@HIDDEN>
> Cc: 47832 <at> debbugs.gnu.org
> 
> > Got it! :-)  The commit I identified is indeed the culprit.  With 
> > USE_CAIRO, gui_init_fringe() is called in x_initialize(); without 
> > USE_CAIRO it isn't.  And gui_init_fringe() had a bug, which should now be 
> > fixed on Windows, too.  Patch attached.
> 
> Thanks, but is this really all that needs to be done?  How will
> gui_init_fringe be called in the non-Cairo builds?  And what about NS?

Answering myself: they don't need to call gui_init_fringe.  Since
gui_init_fringe returns immediately if the frame interface doesn't
provide a method for fringe initialization, I think we should call
gui_init_fringe unconditionally on X.

And in any case, the patch for gui_init_fringe is sub-optimal: it
unnecessarily loops over the standard bitmaps that were superseded.
It is better to leave the first loop go over the standard bitmaps,
whether superseded or not, and the second loop go over non-standard
bitmaps only.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47832; Package emacs. Full text available.

Message received at 47832 <at> debbugs.gnu.org:


Received: (at 47832) by debbugs.gnu.org; 17 Apr 2021 10:57:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Apr 17 06:57:36 2021
Received: from localhost ([127.0.0.1]:42357 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lXido-0002Cq-GJ
	for submit <at> debbugs.gnu.org; Sat, 17 Apr 2021 06:57:36 -0400
Received: from eggs.gnu.org ([209.51.188.92]:50224)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lXidj-0002CW-9N
 for 47832 <at> debbugs.gnu.org; Sat, 17 Apr 2021 06:57:30 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:60041)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lXidd-0008MV-Ff; Sat, 17 Apr 2021 06:57:21 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:3252
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lXida-0001GD-5P; Sat, 17 Apr 2021 06:57:19 -0400
Date: Sat, 17 Apr 2021 13:57:14 +0300
Message-Id: <83h7k5w54l.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Gregory Heytings <gregory@HIDDEN>
In-Reply-To: <1869622e16688e6aedec@HIDDEN> (message from Gregory
 Heytings on Sat, 17 Apr 2021 09:49:46 +0000)
Subject: Re: bug#47832: 28.0.50; define-fringe-bitmap and emacs --daemon
References: <7dee3f4235cf450a3254@HIDDEN> <83mttxwgm8.fsf@HIDDEN>
 <1869622e16688e6aedec@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47832
Cc: 47832 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> Date: Sat, 17 Apr 2021 09:49:46 +0000
> From: Gregory Heytings <gregory@HIDDEN>
> cc: 47832 <at> debbugs.gnu.org
> 
> This used to work indeed; it worked on GNU/Linux with default (non-Cairo) 
> builds for Emacs 24 to 27.

And with Emacs 28 it doesn't work in non-Cairo builds?

> Got it! :-)  The commit I identified is indeed the culprit.  With 
> USE_CAIRO, gui_init_fringe() is called in x_initialize(); without 
> USE_CAIRO it isn't.  And gui_init_fringe() had a bug, which should now be 
> fixed on Windows, too.  Patch attached.

Thanks, but is this really all that needs to be done?  How will
gui_init_fringe be called in the non-Cairo builds?  And what about NS?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47832; Package emacs. Full text available.

Message received at 47832 <at> debbugs.gnu.org:


Received: (at 47832) by debbugs.gnu.org; 17 Apr 2021 09:49:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Apr 17 05:49:51 2021
Received: from localhost ([127.0.0.1]:42318 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lXhaI-0000Kv-Ts
	for submit <at> debbugs.gnu.org; Sat, 17 Apr 2021 05:49:51 -0400
Received: from heytings.org ([95.142.160.155]:41468)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <gregory@HIDDEN>) id 1lXhaF-0000Kk-Rc
 for 47832 <at> debbugs.gnu.org; Sat, 17 Apr 2021 05:49:49 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=heytings.org;
 s=20210101; t=1618652986;
 bh=+miRQ7Cjg3t1J0eTsPnUaOiFqSOWlgSGEyLqBUCoeD0=;
 h=Date:From:To:cc:Subject:In-Reply-To:Message-ID:References:From;
 b=EipFU2F8cBTcY1VBLrW1taCRlI7Ij8C2XGWRlSjd0IKF2UeVvBhASvCjmZhWg8Aqr
 hQM8Mb0mtaDrOiofRoJ5tUYXSox4DbpfSsscgP4O6/i4AYmorbRYX/PVcUXlkqUbzW
 2yic/46ScqDPch6d/QP8697OZIQjoZW6JU1Rh35kKPNwSHbYwcjSfUcOJ1x5QqHW6Y
 KENmNuRSi0oa5wCQO8XHnm+VYqLt3BsnnR3CgR1oOniNXvSQUEpyggEJpjbcvhL/XR
 MKf4D9gbx5ct8AjbWoBvNUuor91Pj3exU0sz/TLGyeGsxNvlngonhHTnhWWmuB84Ew
 2LZYHg+kiFZDQ==
Date: Sat, 17 Apr 2021 09:49:46 +0000
From: Gregory Heytings <gregory@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#47832: 28.0.50; define-fringe-bitmap and emacs --daemon
In-Reply-To: <83mttxwgm8.fsf@HIDDEN>
Message-ID: <1869622e16688e6aedec@HIDDEN>
References: <7dee3f4235cf450a3254@HIDDEN> <83mttxwgm8.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="wSN0riL65Y"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 47832
Cc: 47832 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


--wSN0riL65Y
Content-Type: text/plain; format=flowed; charset=us-ascii


>
> However, if this used to work,
>

This used to work indeed; it worked on GNU/Linux with default (non-Cairo) 
builds for Emacs 24 to 27.

>
> it would be good to understand which change broke it.
>

Got it! :-)  The commit I identified is indeed the culprit.  With 
USE_CAIRO, gui_init_fringe() is called in x_initialize(); without 
USE_CAIRO it isn't.  And gui_init_fringe() had a bug, which should now be 
fixed on Windows, too.  Patch attached.
--wSN0riL65Y
Content-Type: text/x-diff; name=Consider-all-user-defined-bitmaps-in-gui_init_fringe.patch
Content-Transfer-Encoding: base64
Content-ID: <1869622e1674b457f9ca@HIDDEN>
Content-Description: 
Content-Disposition: attachment; filename=Consider-all-user-defined-bitmaps-in-gui_init_fringe.patch

RnJvbSA0ZDVhMThiYmIxODQ5NmViMDJlOTQ5Yjk5M2NjM2Y5YmNhN2M0ZDkx
IE1vbiBTZXAgMTcgMDA6MDA6MDAgMjAwMQ0KRnJvbTogR3JlZ29yeSBIZXl0
aW5ncyA8Z3JlZ29yeUBoZXl0aW5ncy5vcmc+DQpEYXRlOiBTYXQsIDE3IEFw
ciAyMDIxIDA5OjM3OjIxICswMDAwDQpTdWJqZWN0OiBbUEFUQ0hdIENvbnNp
ZGVyIGFsbCB1c2VyLWRlZmluZWQgYml0bWFwcyBpbiBndWlfaW5pdF9mcmlu
Z2UoKQ0KDQoqIHNyYy9mcmluZ2UuYyAoZ3VpX2luaXRfZnJpbmdlKTogQWxz
byBjb25zaWRlciB1c2VyLWRlZmluZWQgYml0bWFwcyB0aGF0DQpvdmVycmlk
ZSBkZWZhdWx0IG9uZXMgKEJ1ZyM0NzgzMikuDQotLS0NCiBzcmMvZnJpbmdl
LmMgfCAyICstDQogMSBmaWxlIGNoYW5nZWQsIDEgaW5zZXJ0aW9uKCspLCAx
IGRlbGV0aW9uKC0pDQoNCmRpZmYgLS1naXQgYS9zcmMvZnJpbmdlLmMgYi9z
cmMvZnJpbmdlLmMNCmluZGV4IDY1YzlhODRhYzkuLmYyYjYwYjVjOGUgMTAw
NjQ0DQotLS0gYS9zcmMvZnJpbmdlLmMNCisrKyBiL3NyYy9mcmluZ2UuYw0K
QEAgLTE3ODMsNyArMTc4Myw3IEBAIGd1aV9pbml0X2ZyaW5nZSAoc3RydWN0
IHJlZGlzcGxheV9pbnRlcmZhY2UgKnJpZikNCiAgICAgIGJlZm9yZSB0aGUg
ZnJhbWUgb2YgdGhpcyBraW5kIHdhcyBpbml0aWFsaXplZC4gIFRoaXMgY2Fu
IGhhcHBlbg0KICAgICAgaWYgRW1hY3MgaXMgc3RhcnRlZCBhcyBhIGRhZW1v
biBhbmQgdGhlIGluaXQgZmlsZXMgZGVmaW5lIGZyaW5nZQ0KICAgICAgYml0
bWFwcy4gICovDQotICBmb3IgKCA7IGJ0IDwgbWF4X3VzZWRfZnJpbmdlX2Jp
dG1hcDsgYnQrKykNCisgIGZvciAoYnQgPSBOT19GUklOR0VfQklUTUFQICsg
MTsgYnQgPCBtYXhfdXNlZF9mcmluZ2VfYml0bWFwOyBidCsrKQ0KICAgICB7
DQogICAgICAgc3RydWN0IGZyaW5nZV9iaXRtYXAgKmZiID0gZnJpbmdlX2Jp
dG1hcHNbYnRdOw0KICAgICAgIGlmIChmYikNCi0tIA0KMi4zMC4yDQoNCg==

--wSN0riL65Y--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47832; Package emacs. Full text available.

Message received at 47832 <at> debbugs.gnu.org:


Received: (at 47832) by debbugs.gnu.org; 17 Apr 2021 06:49:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Apr 17 02:49:16 2021
Received: from localhost ([127.0.0.1]:42145 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lXelY-0004NP-Ba
	for submit <at> debbugs.gnu.org; Sat, 17 Apr 2021 02:49:16 -0400
Received: from eggs.gnu.org ([209.51.188.92]:47700)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lXelW-0004N9-Bw
 for 47832 <at> debbugs.gnu.org; Sat, 17 Apr 2021 02:49:15 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:58335)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lXelQ-0000L6-Kz; Sat, 17 Apr 2021 02:49:08 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:3696
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lXelQ-0004ms-02; Sat, 17 Apr 2021 02:49:08 -0400
Date: Sat, 17 Apr 2021 09:49:03 +0300
Message-Id: <83mttxwgm8.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Gregory Heytings <gregory@HIDDEN>
In-Reply-To: <7dee3f4235cf450a3254@HIDDEN> (message from Gregory
 Heytings on Fri, 16 Apr 2021 22:22:35 +0000)
Subject: Re: bug#47832: 28.0.50; define-fringe-bitmap and emacs --daemon
References: <7dee3f4235cf450a3254@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47832
Cc: 47832 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> Date: Fri, 16 Apr 2021 22:22:35 +0000
> From: Gregory Heytings <gregory@HIDDEN>
> 
> When the init file contains define-fringe-bitmap that override default 
> fringe bitmaps, they are ignored by Emacs when it is started as a daemon. 
> This has stopped working at commit 88efc736f5, when Cairo became the 
> default backend.

That commit simply made Cairo being available by default, if found on
the system.  It didn't change any code.  Are you saying that non-Cairo
build shows this problem as well, after that commit?  Or is the
problem limited to Cairo builds on your system?

> 1. create a ~/.emacs file with:
> 
> (define-fringe-bitmap 'empty-line [ #xff ] nil nil '(top t))
> (setq-default indicate-empty-lines t)
> 
> 2. emacs ~/.emacs => the empty lines fringe bitmaps are displayed 
> correctly, with a solid black column.
> 
> 3. emacs --daemon
> 
> 4. emacsclient -c ~/.emacs => the empty line fringe bitmaps are the 
> default ones, which are 4x1 pixel horizontal black lines.

In general, display features that need GUI framework should be turned
on from after-make-frame-functions or server-after-make-frame-hook to
work reliably in daemon-based sessions.  However, if this used to
work, it would be good to understand which change broke it.  But I
doubt that the commit you identified is the culprit: I see the same
behavior on MS-Windows, where Cairo and the commit you pointed to have
no effect whatsoever.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47832; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 16 Apr 2021 22:22:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Apr 16 18:22:45 2021
Received: from localhost ([127.0.0.1]:41914 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lXWrM-0000Bg-NR
	for submit <at> debbugs.gnu.org; Fri, 16 Apr 2021 18:22:44 -0400
Received: from lists.gnu.org ([209.51.188.17]:51858)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <gregory@HIDDEN>) id 1lXWrK-0000BY-PP
 for submit <at> debbugs.gnu.org; Fri, 16 Apr 2021 18:22:43 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:57488)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <gregory@HIDDEN>)
 id 1lXWrK-00029w-GM
 for bug-gnu-emacs@HIDDEN; Fri, 16 Apr 2021 18:22:42 -0400
Received: from heytings.org ([95.142.160.155]:44784)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <gregory@HIDDEN>)
 id 1lXWrG-0003LM-C6
 for bug-gnu-emacs@HIDDEN; Fri, 16 Apr 2021 18:22:40 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=heytings.org;
 s=20210101; t=1618611755;
 bh=CY02i+4o9eIOM7403JJHB774Y8AlUAoK3KREpf4LhmA=;
 h=Date:From:To:Subject:Message-ID:From;
 b=Bw3ne4WRutVBPF4h7jyjbM95pLR4zIlNkPD/4QND124hFrUkXs6AqEghtzKZ2qDkG
 shfmric2qL2xN2UEpe0Ousv82GPubzd1GA6U9NIwY5lHfjtGNFA3vwo2gVfrHvcUJH
 3qs6Js80YSUD8NEbLtydZkL6YF1oacldPItmjLU44IBvmW+TKOMD23NegMoMcXl7Wo
 GMFAG124mayAQbflLfujM5dUgP/qtY1BxhjtJgBvcc5Pn6uJQ/EN1hQdUDGe1Xl2lf
 qI9zvJ2ZMnDzXrSvw1+5SYCWRnIPGB7IColPSNOHWIBbCIgaFobIUqCZo6gxD6iYWi
 B1xhzfF55Nxkg==
Date: Fri, 16 Apr 2021 22:22:35 +0000
From: Gregory Heytings <gregory@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 28.0.50; define-fringe-bitmap and emacs --daemon
Message-ID: <7dee3f4235cf450a3254@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed; charset=us-ascii
Received-SPF: pass client-ip=95.142.160.155; envelope-from=gregory@HIDDEN;
 helo=heytings.org
X-Spam_score_int: -20
X-Spam_score: -2.1
X-Spam_bar: --
X-Spam_report: (-2.1 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1, SPF_HELO_PASS=-0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)


When the init file contains define-fringe-bitmap that override default 
fringe bitmaps, they are ignored by Emacs when it is started as a daemon. 
This has stopped working at commit 88efc736f5, when Cairo became the 
default backend.

How to reproduce:

1. create a ~/.emacs file with:

(define-fringe-bitmap 'empty-line [ #xff ] nil nil '(top t))
(setq-default indicate-empty-lines t)

2. emacs ~/.emacs => the empty lines fringe bitmaps are displayed 
correctly, with a solid black column.

3. emacs --daemon

4. emacsclient -c ~/.emacs => the empty line fringe bitmaps are the 
default ones, which are 4x1 pixel horizontal black lines.

When the init file contains define-fringe-bitmap that do _not_ override 
default fringe bitmaps however, they are not ignored.  For example with

(define-fringe-bitmap 'solid [ #xff ] nil nil '(top t))

the "solid" fringe bitmap can be used in frames created by emacsclient -c.




Acknowledgement sent to Gregory Heytings <gregory@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#47832; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Mon, 3 May 2021 00:45:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.